#### START of bare-bones minimum Falcon script ####

on load {
  set filename dalmenu.tcl

  if {[set idx [lsearch [scripts] "*\\$filename"]]== -1} {
    error "Unable to find path for $filename"
  } else {
    regexp -nocase (.*)\\$filename\$ [lindex [scripts] $idx] a scriptDir
    unset a
    load $scriptDir/falcon.dll

    if {[set ver [FALC_ver]] < 1.51} {
      error "falcon.dll is v$ver. This script needs at least version 1.51 of falcon."
    }

  }
}

# This is used for falcon's internal notifier.
# Have this in !ALL! scripts using falcon.
on timer {
    if {[llength [info commands FALC_update]]} { FALC_update }
}

#### END of bare-bones minimum falcon.dll script ####

on notice {
    set dlgTitle "Notice from [nick]"

    if {[string tolower [nick]] == "nickserv"} {
        set theMessage [join [lrange [args] 1 end]]
        set theMessage [split $theMessage]
#        incr nameEnd -3

        if {[lindex $theMessage 0] == "ACC"} {
            set theNick [lindex $theMessage 1]
            set theAccess [lindex $theMessage 2]

            switch $theAccess {
                "0"
                    {msgbox $dlgTitle "$theNick is not registered."}

                "1"
                    {msgbox $dlgTitle "$theNick is not currently online or is not recognized."}

                "2"
                    {msgbox $dlgTitle "$theNick is recognized by the access list."}

                "3"
                    {msgbox $dlgTitle "$theNick is recognized by password."}
            }

            complete
        }
    }
}

#-----------------------------------
# Dalnet channel operations
#-----------------------------------
menu channel "&Dalnet->&Register..." {
    set itemList [list]

    lappend itemList [list label label1 9 9 65 10 "Channel to register:"]
    lappend itemList [list edit chanName 77 7 150 12 [channel]]
    lappend itemList [list label label2 9 27 65 10 "Password:"]
    lappend itemList [list edit pass 77 24 150 12]
    lappend itemList [list label label3 9 45 65 10 "Description:"]
    lappend itemList [list edit desc 77 42 150 12]

    set answer [FALC_dialog -t "Register channel" 244 65 $itemList]
    echo $answer status

    foreach control $answer {
        set [lindex $control 0] [lindex $control 1]
    }

    set desc [join $desc]

    /chanserv register $chanName $pass $desc

    complete
}

menu channel "&Dalnet->&Identify..." {
    set thePass [prompt "Identify for channel [channel]" "Enter the password for [channel]:"]

    if {[string length $thePass]} {
        /chanserv identify [channel] $thePass
    }
}

menu channel "&Dalnet->&Drop" {
    /chanserv drop [channel]
}

menu channel "&Dalnet->" {}

menu channel "&Dalnet->Channel &Info..." {
    /chanserv info [channel]
}

menu channel "&Dalnet->Send &Memo to Channel..." {
    set itemList [list]

    lappend itemList [list label label1 9 9 30 10 "Message:"]
    lappend itemList [list edit theMessage 44 7 105 12]
    lappend itemList [list check -v 0 sop 9 25 80 10 "Send to &SOPs only"]

    set answer [FALC_dialog -t "Send memo to [channel]" 160 40 $itemList]

    foreach control $answer {
        set [lindex $control 0] [lindex $control 1]
    }

    if {[string length $theMessage]} {
        if {$sop} {
            /memoserv sendsop [channel] $theMessage
        } else {
            /memoserv send [channel] $theMessage
        }
    }
}

menu channel "&Dalnet->" {}

menu channel "&Dalnet->&Set->&Founder" {
    /chanserv set [channel] founder
}

menu channel "&Dalnet->&Set->&Password..." {
    set newPass [prompt "New Password for [channel]" "Enter the new password for [channel]:"]

    if {[string length $newPass]} {
        /chanserv set [channel] passwd $newPass
    }
}

menu channel "&Dalnet->&Set->&Description..." {
    set newDesc [prompt "New Description for [channel]" "Enter the new description for [channel]:"]

    if {[string length $newDesc]} {
        /chanserv set [channel] desc $newDesc
    }
}


menu channel "&Dalnet->&Set->&URL..." {
    set newURL [prompt "New URL for [channel]" "Enter the new URL for [channel]:"]

    if {[string length $newURL]} {
        /chanserv set [channel] url $newURL
    }
}

menu channel "&Dalnet->&Set->" {}

menu channel "&Dalnet->&Set->&Topic Lock->&Off" {
    /chanserv set [channel] topiclock off
}

menu channel "&Dalnet->&Set->&Topic Lock->&SOP" {
    /chanserv set [channel] topiclock sop
}

menu channel "&Dalnet->&Set->&Topic Lock->&Founder" {
    /chanserv set [channel] topiclock founder
}

menu channel "&Dalnet->&Set->&Memo Level->&AOP" {
    /chanserv set [channel] memo aop
}

menu channel "&Dalnet->&Set->&Memo Level->&SOP" {
    /chanserv set [channel] memo sop
}

menu channel "&Dalnet->&Set->&Memo Level->&Founder" {
    /chanserv set [channel] memo founder
}

menu channel "&Dalnet->&Set->&Memo Level->&None" {
    /chanserv set [channel] memo none
}

menu channel "&Dalnet->&Set->Mode &Lock..." {
    set lockMask [prompt "Mode Lock for [channel]" "Enter the modes to lock for [channel]:"]

    if {[string length $lockMask]} {
        /chanserv set [channel] mlock $lockMask
    }
}

menu channel "&Dalnet->&Set->" {}

menu channel "&Dalnet->&Set->&Restricted Access->&On" {
    /chanserv set [channel] restrict on
}

menu channel "&Dalnet->&Set->&Restricted Access->O&ff" {
    /chanserv set [channel] restrict off
}

menu channel "&Dalnet->&Set->Sticky &Topics->&On" {
    /chanserv set [channel] keeptopic on
}

menu channel "&Dalnet->&Set->Sticky &Topics->O&ff" {
    /chanserv set [channel] keeptopic off
}

menu channel "&Dalnet->&Set->&Ident->&On" {
    /chanserv set [channel] ident on
}

menu channel "&Dalnet->&Set->&Ident->O&ff" {
    /chanserv set [channel] ident off
}

menu channel "&Dalnet->&Set->&Secure ops->&On" {
    /chanserv set [channel] opguard on
}

menu channel "&Dalnet->&Set->&Secure ops->O&ff" {
    /chanserv set [channel] opguard off
}

menu channel "&Dalnet->&Set->&Leave ops->&On" {
    /chanserv set [channel] leaveops on
}

menu channel "&Dalnet->&Set->&Leave ops->O&ff" {
    /chanserv set [channel] leaveops off
}

menu channel "&Dalnet->&Set->&Unsecured->&On" {
    /chanserv set [channel] unsecure on
}

menu channel "&Dalnet->&Set->&Unsecured->O&ff" {
    /chanserv set [channel] unsecure off
}


menu channel "&Dalnet->&Access Lists->&AOP->&Show..." {
    /chanserv aop [channel] list
}

menu channel "&Dalnet->&Access Lists->&AOP->&Edit..." {
    set itemList [list]
    set dlgTitle "Edit AOP list for [channel]"

    lappend itemList [list label label1 92 9 43 10 "Nick / Mask:"]
    lappend itemList [list edit mask 139 7 75 12]
    lappend itemList [list combo -x action 35 7 50 12 {Add Del}]
    lappend itemList [list label label2 9 9 21 10 "Action:"]

    set answer [FALC_dialog -t $dlgTitle 226 36 $itemList]

    foreach control $answer {
        set [lindex $control 0] [lindex $control 1]
    }

    /chanserv aop [channel] $action $mask

}

menu channel "&Dalnet->&Access Lists->&SOP->&Show..." {
    /chanserv sop [channel] list
}

menu channel "&Dalnet->&Access Lists->&SOP->&Edit..." {
    set itemList [list]
    set dlgTitle "Edit SOP list for [channel]"

    lappend itemList [list label label1 92 9 43 10 "Nick / Mask:"]
    lappend itemList [list edit mask 139 7 75 12]
    lappend itemList [list combo -x action 35 7 50 12 {Add Del}]
    lappend itemList [list label label2 9 9 21 10 "Action:"]

    set answer [FALC_dialog -t $dlgTitle 226 36 $itemList]

    foreach control $answer {
        set [lindex $control 0] [lindex $control 1]
    }

    /chanserv sop [channel] $action $mask

}

menu channel "&Dalnet->&Access Lists->A&KICK->&Show..." {
    /chanserv akick [channel] list
}

menu channel "&Dalnet->&Access Lists->A&KICK->&Edit..." {
    set itemList [list]
    set dlgTitle "Edit AKICK list for [channel]"

    lappend itemList [list label label1 92 9 43 10 "Nick / Mask:"]
    lappend itemList [list edit mask 139 7 75 12]
    lappend itemList [list combo -x action 35 7 50 12 {Add Del}]
    lappend itemList [list label label2 9 9 21 10 "Action:"]

    set answer [FALC_dialog -t $dlgTitle 226 36 $itemList]

    foreach control $answer {
        set [lindex $control 0] [lindex $control 1]
    }

    /chanserv akick [channel] $action $mask

}

menu channel "&Dalnet->" {}

menu channel "&Dalnet->Mass &Deop" {
    /chanserv mdeop [channel]
}

menu channel "&Dalnet->Mass &Kick" {
    /chanserv mkick [channel]
}

menu users "" {}

menu users "&Dalnet->&Chanserv->&Op" {
    foreach nick [args] {
        /chanserv op [channel] $nick
    }
}

menu users "&Dalnet->&Chanserv->&Explain..." {
    foreach nick [args] {
        /chanserv why [channel] $nick
    }
}

#------------------------------------
# Dalnet nickname operations
#------------------------------------
menu status "&Dalnet->&Nickserv->&Register..." {
        set newPass [prompt "Register nickname [my_nick]" "Enter the new password for nick [my_nick]:"]

        if {[string length $newPass]} {
            /nickserv register $newPass
        }
}

menu status "&Dalnet->&Nickserv->&Identify..." {
        set newPass [prompt "Identify for nickname [my_nick]" "Enter the password for nick [my_nick]:"]

        if {[string length $newPass]} {
            /nickserv identify $newPass
        }
}

menu status "&Dalnet->&Nickserv->&Drop" {
        /nickserv drop
}

menu users "&Dalnet->&Nickserv->&Info..." {
    set nickList [args]

    foreach theNick $nickList {
        /nickserv info $theNick
    }
}

menu status "&Dalnet->&Nickserv->Access &List->&Show..." {
    /nickserv access list
}

menu status "&Dalnet->&Nickserv->Access &List->&Edit..." {
    set theNick [lindex [args] 0]

        set itemList [list]
        set dlgTitle "Edit access list for [my_nick]"

        lappend itemList [list label label1 92 9 43 10 "Mask:"]
        lappend itemList [list edit mask 139 7 75 12]
        lappend itemList [list combo -x action 35 7 50 12 {Add Del}]
        lappend itemList [list label label2 9 9 21 10 "Action:"]

        set answer [FALC_dialog -t $dlgTitle 226 36 $itemList]

        foreach control $answer {
            set [lindex $control 0] [lindex $control 1]
        }

        /nickserv access $action $mask

}

menu status "&Dalnet->&Nickserv->&Set->&Password..." {
        set newPass [prompt "New password for nickname [my_nick]" "Enter the new password for nick [my_nick]:"]

        if {[string length $newPass]} {
            /nickserv register $newPass
        }
}

menu status "&Dalnet->&Nickserv->&Set->&URL..." {
        set newURL [prompt "New URL for nickname [my_nick]" "Enter the new URL for nick [my_nick]:"]

        if {[string length $newURL]} {
            /nickserv register $newURL
        }
}

menu status "&Dalnet->&Nickserv->&Set->" {}

menu status "&Dalnet->&Nickserv->&Set->&Kill->&On" {
        /nickserv set kill on
}

menu status "&Dalnet->&Nickserv->&Set->&Kill->O&ff" {
        /nickserv set kill off
}

menu status "&Dalnet->&Nickserv->&Set->&AOP/SOP Disable->&On" {
        /nickserv set noop on
}

menu status "&Dalnet->&Nickserv->&Set->&AOP/SOP Disable->O&ff" {
        /nickserv set noop off
}

menu status "&Dalnet->&Nickserv->&Set->&Memo Disable->&On" {
        /nickserv set nomemo on
}

menu status "&Dalnet->&Nickserv->&Set->&Memo Disable->O&ff" {
        /nickserv set nomemo off
}

menu users "&Dalnet->&Nickserv->" {}

menu users "&Dalnet->&Nickserv->&Status..." {
    set nickList [args]

    if {![string match *.dal.net* [server]]} {
        FALC_askbox -b ok -t "Command Error" -i info -d ok "This command is valid only on Dalnet."
    } else {
        foreach theNick $nickList {
            /nickserv acc $theNick
        }
    }
}

menu users "&Dalnet->&Nickserv->Kill &Ghost..." {
    foreach nick [args] {
        if {[string match $nick [my_nick]]} {
            FALC_askbox -b ok -t "Command Error" -i info -d ok "You may not use this command on your nick."
        } else {
            set thePass [prompt "Kill ghost $nick" "Enter the password for $nick:"]

            /nickserv ghost $nick $thePass
        }
    }
}

#-----------------------------------
# Dalnet memo operations
#-----------------------------------

menu users "&Dalnet->&Memoserv->&Send to..." {
    set theMessage [prompt "Send memo" "Enter your message:"]

    if {[string length $theMessage]} {
        foreach nick [args] {
            /memoserv send $nick $theMessage
        }
    }
}

menu users "&Dalnet->&Memoserv->&Forward to" {
    if {[llength [args]] > 1} {
        FALC_askbox -t "Command Error" -b ok -i info "This command may not be used on a multiple selection."
    } elseif {[string match [lindex [args] 0] [my_nick]} {
        FALC_askbox -t "Command Error" -b ok -i info "You may not forward memos to yourself."
    } else {
        /memoserv forward [lindex [args] 0]
    }
}

menu status "&Dalnet->&Memoserv->&List memos..." {
    /memoserv list
}

menu status "&Dalnet->&Memoserv->&Read memos..." {
    set theNum [prompt "Read memos" "Enter the number of the memo to read:"]

    if {[string length $theNum]} {
        /memoserv read $theNum
    }
}

menu status "&Dalnet->&Memoserv->&Mark memos for deletion..." {
    set itemList [list]

    lappend itemList [list label label1 9 9 40 10 "Memo #'s to delete:"]
    lappend itemList [list edit memoNums 54 7 35 12]

    set answer [FALC_dialog -t "Delete memos" 98 34 $itemList]

    foreach control $answer {
        set [lindex $control 0] [lindex $control 1]
    }

    set numList [split $memoNums ", "]

    foreach num $numList {
        /memoserv del $num
    }
}

menu status "&Dalnet->&Memoserv->&Purge memos->&Marked" {
    /memoserv purge
}

menu status "&Dalnet->&Memoserv->&Purge memos->&All" {
    /memoserv del all
}

menu status "&Dalnet->&Memoserv->&Cancel memo forwarding" {
    /memoserv forward off
}